/* $Id: pixela.c,v 1.3 2001/09/21 06:25:42 skids Exp $
******************************************************************************

   Graphics library for GGI. Pixels.

   Copyright (C) 1997 Jason McMullan [jmcc@ggi-project.org]
   Copyright (C) 1995 Andreas Beck [becka@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


#include "stubs-a8-z8-lib.h"
#include <ggi/internal/buf.h>

int GGI_stubs_a8_z8_drawpixela(ggi_visual *vis,int x,int y)
{
	ggi_pixel col, curr;
	CHECKXY(vis,x,y);
	PREPARE_FB(vis);
	ggiGetGCForeground(vis, &col);
	LIBGGI_BUFEXT(vis)->old_opdraw->getpixel(vis, x, y, &curr);
	return LIBGGI_BUFEXT(vis)->old_opdraw->putpixel_nc(
	        vis, x, y, calc_pixel(vis, x, y, col, curr));
}

int GGI_stubs_a8_z8_drawpixel_nca(ggi_visual *vis,int x,int y)
{
	ggi_pixel col, curr;
	PREPARE_FB(vis);
	ggiGetGCForeground(vis, &col);
	LIBGGI_BUFEXT(vis)->old_opdraw->getpixel(vis, x, y, &curr);
	return LIBGGI_BUFEXT(vis)->old_opdraw->putpixel_nc(
	        vis, x, y, calc_pixel(vis, x, y, col, curr));
}

int GGI_stubs_a8_z8_putpixel_nca(ggi_visual *vis,int x,int y,ggi_pixel col)
{ 
	ggi_pixel curr;
	PREPARE_FB(vis);
	LIBGGI_BUFEXT(vis)->old_opdraw->getpixel(vis, x, y, &curr);
	return LIBGGI_BUFEXT(vis)->old_opdraw->putpixel_nc(
	        vis, x, y, calc_pixel(vis, x, y, col, curr));
}

int GGI_stubs_a8_z8_putpixela(ggi_visual *vis,int x,int y,ggi_pixel col)
{ 
	ggi_pixel curr;
	CHECKXY(vis,x,y);
	PREPARE_FB(vis);
	LIBGGI_BUFEXT(vis)->old_opdraw->getpixel(vis, x, y, &curr);
	return LIBGGI_BUFEXT(vis)->old_opdraw->putpixel_nc(
	        vis, x, y, calc_pixel(vis, x, y, col, curr));
}
